SFML - Simple and Fast Multimedia Library

SFML 3.0.1

- Main Page
- Topics
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Protected Member Functions | List of all members
sf::SoundStream Class Referenceabstract
Audio module

Abstract base class for streamed audio sources. More...

`#include <SFML/Audio/SoundStream.hpp>`

Inheritance diagram for sf::SoundStream:

## Classes
struct | Chunk
| Structure defining a chunk of audio data to stream. More...

## Public Types
enum class | Status { Stopped , Paused , Playing }
| Enumeration of the sound source states. More...
using | EffectProcessor
| Callable that is provided with sound data for processing.

## Public Member Functions
| ~SoundStream () override
| Destructor.
| SoundStream (SoundStream &&) noexcept
| Move constructor.
SoundStream & | operator= (SoundStream &&) noexcept
| Move assignment.
void | play () override
| Start or resume playing the audio stream.
void | pause () override
| Pause the audio stream.
void | stop () override
| Stop playing the audio stream.
unsigned int | getChannelCount () const
| Return the number of channels of the stream.
unsigned int | getSampleRate () const
| Get the stream sample rate of the stream.
std::vector< SoundChannel > | getChannelMap () const
| Get the map of position in sample frame to sound channel.
Status | getStatus () const override
| Get the current status of the stream (stopped, paused, playing)
void | setPlayingOffset (Time timeOffset)
| Change the current playing position of the stream.
Time | getPlayingOffset () const
| Get the current playing position of the stream.
void | setLooping (bool loop)
| Set whether or not the stream should loop after reaching the end.
bool | isLooping () const
| Tell whether or not the stream is in loop mode.
void | setEffectProcessor (EffectProcessor effectProcessor) override
| Set the effect processor to be applied to the sound.
void | setPitch (float pitch)
| Set the pitch of the sound.
void | setPan (float pan)
| Set the pan of the sound.
void | setVolume (float volume)
| Set the volume of the sound.
void | setSpatializationEnabled (bool enabled)
| Set whether spatialization of the sound is enabled.
void | setPosition (const Vector3f &position)
| Set the 3D position of the sound in the audio scene.
void | setDirection (const Vector3f &direction)
| Set the 3D direction of the sound in the audio scene.
void | setCone (const Cone &cone)
| Set the cone properties of the sound in the audio scene.
void | setVelocity (const Vector3f &velocity)
| Set the 3D velocity of the sound in the audio scene.
void | setDopplerFactor (float factor)
| Set the doppler factor of the sound.
void | setDirectionalAttenuationFactor (float factor)
| Set the directional attenuation factor of the sound.
void | setRelativeToListener (bool relative)
| Make the sound's position relative to the listener or absolute.
void | setMinDistance (float distance)
| Set the minimum distance of the sound.
void | setMaxDistance (float distance)
| Set the maximum distance of the sound.
void | setMinGain (float gain)
| Set the minimum gain of the sound.
void | setMaxGain (float gain)
| Set the maximum gain of the sound.
void | setAttenuation (float attenuation)
| Set the attenuation factor of the sound.
float | getPitch () const
| Get the pitch of the sound.
float | getPan () const
| Get the pan of the sound.
float | getVolume () const
| Get the volume of the sound.
bool | isSpatializationEnabled () const
| Tell whether spatialization of the sound is enabled.
Vector3f | getPosition () const
| Get the 3D position of the sound in the audio scene.
Vector3f | getDirection () const
| Get the 3D direction of the sound in the audio scene.
Cone | getCone () const
| Get the cone properties of the sound in the audio scene.
Vector3f | getVelocity () const
| Get the 3D velocity of the sound in the audio scene.
float | getDopplerFactor () const
| Get the doppler factor of the sound.
float | getDirectionalAttenuationFactor () const
| Get the directional attenuation factor of the sound.
bool | isRelativeToListener () const
| Tell whether the sound's position is relative to the listener or is absolute.
float | getMinDistance () const
| Get the minimum distance of the sound.
float | getMaxDistance () const
| Get the maximum distance of the sound.
float | getMinGain () const
| Get the minimum gain of the sound.
float | getMaxGain () const
| Get the maximum gain of the sound.
float | getAttenuation () const
| Get the attenuation factor of the sound.

## Protected Member Functions
| SoundStream ()
| Default constructor.
void | initialize (unsigned int channelCount, unsigned int sampleRate, const std::vector< SoundChannel > &channelMap)
| Define the audio stream parameters.
virtual bool | onGetData (Chunk &data)=0
| Request a new chunk of audio samples from the stream source.
virtual void | onSeek (Time timeOffset)=0
| Change the current playing position in the stream source.
virtual std::optional< std::uint64_t > | onLoop ()
| Change the current playing position in the stream source to the beginning of the loop.

## Detailed Description

Abstract base class for streamed audio sources.

Unlike audio buffers (see `sf::SoundBuffer`), audio streams are never completely loaded in memory.

Instead, the audio data is acquired continuously while the stream is playing. This behavior allows to play a sound with no loading delay, and keeps the memory consumption very low.

Sound sources that need to be streamed are usually big files (compressed audio musics that would eat hundreds of MB in memory) or files that would take a lot of time to be received (sounds played over the network).

`sf::SoundStream` is a base class that doesn't care about the stream source, which is left to the derived class. SFML provides a built-in specialization for big files (see `sf::Music`). No network stream source is provided, but you can write your own by combining this class with the network module.

A derived class has to override two virtual functions:

- `onGetData` fills a new chunk of audio data to be played
- `onSeek` changes the current playing position in the source

It is important to note that each SoundStream is played in its own separate thread, so that the streaming loop doesn't block the rest of the program. In particular, the `onGetData` and `onSeek` virtual functions may sometimes be called from this separate thread. It is important to keep this in mind, because you may have to take care of synchronization issues if you share data between threads.

Usage example:

class CustomStream : public sf::SoundStream
{
public:
[[nodiscard]] bool open(const std::string& location)
{
// Open the source and get audio settings
...
unsigned int channelCount = 2; // Stereo
unsigned int sampleRate = 44100; // 44100 Hz
// Initialize the stream -- important!
initialize(channelCount, sampleRate, {sf::SoundChannel::FrontLeft, sf::SoundChannel::FrontRight});
return true;
}
private:
bool onGetData(Chunk& data) override
{
// Fill the chunk with audio data from the stream source
// (note: must not be empty if you want to continue playing)
data.samples = ...;
// Return true to continue playing
data.sampleCount = ...;
return true;
}
void onSeek(sf::Time timeOffset) override
{
// Change the current position in the stream source
...
}
};
// Usage
CustomStream stream;
stream.open("path/to/stream");
stream.play();
sf::SoundStream
Abstract base class for streamed audio sources.
Definition SoundStream.hpp:52
sf::SoundStream::initialize
void initialize(unsigned int channelCount, unsigned int sampleRate, const std::vector< SoundChannel > &channelMap)
Define the audio stream parameters.
sf::SoundStream::onSeek
virtual void onSeek(Time timeOffset)=0
Change the current playing position in the stream source.
sf::SoundStream::onGetData
virtual bool onGetData(Chunk &data)=0
Request a new chunk of audio samples from the stream source.
sf::SoundChannel::FrontRight
@ FrontRight
Definition SoundChannel.hpp:46
sf::SoundChannel::FrontLeft
@ FrontLeft
Definition SoundChannel.hpp:45

See also
  `sf::Music`

Definition at line 51 of file SoundStream.hpp.

## Member Typedef Documentation

## ◆ EffectProcessor

using sf::SoundSource::EffectProcessor
| inherited

Initial value:
std::function<
void(const float* inputFrames, unsigned int& inputFrameCount, float* outputFrames, unsigned int& outputFrameCount, unsigned int frameChannelCount)>

Callable that is provided with sound data for processing.

When the audio engine sources sound data from sound sources it will pass the data through an effects processor if one is set. The sound data will already be converted to the internal floating point format.

Sound data that is processed this way is provided in frames. Each frame contains 1 floating point sample per channel. If e.g. the data source provides stereo data, each frame will contain 2 floats.

The effects processor function takes 4 parameters:

- The input data frames, channels interleaved
- The number of input data frames available
- The buffer to write output data frames to, channels interleaved
- The number of output data frames that the output buffer can hold
- The channel count

The input and output frame counts are in/out parameters.

When this function is called, the input count will contain the number of frames available in the input buffer. The output count will contain the size of the output buffer i.e. the maximum number of frames that can be written to the output buffer.

Attempting to read more frames than the input frame count or write more frames than the output frame count will result in undefined behaviour.

It is important to note that the channel count of the audio engine currently sourcing data from this sound will always be provided in `frameChannelCount`. This can be different from the channel count of the sound source so make sure to size necessary processing buffers according to the engine channel count and not the sound source channel count.

When done processing the frames, the input and output frame counts must be updated to reflect the actual number of frames that were read from the input and written to the output.

The processing function should always try to process as much sound data as possible i.e. always try to fill the output buffer to the maximum. In certain situations for specific effects it can be possible that the input frame count and output frame count aren't equal. As long as the frame counts are updated accordingly this is perfectly valid.

If the audio engine determines that no audio data is available from the data source, the input data frames pointer is set to `nullptr` and the input frame count is set to 0. In this case it is up to the function to decide how to handle the situation. For specific effects e.g. Echo/Delay buffered data might still be able to be written to the output buffer even if there is no longer any input data.

An important thing to remember is that this function is directly called by the audio engine. Because the audio engine runs on an internal thread of its own, make sure access to shared data is synchronized appropriately.

Because this function is stored by the `SoundSource` object it will be able to be called as long as the `SoundSource` object hasn't yet been destroyed. Make sure that any data this function references outlives the SoundSource object otherwise use-after-free errors will occur.

Definition at line 154 of file SoundSource.hpp.

## Member Enumeration Documentation

## ◆ Status

enum class sf::SoundSource::Status
| stronginherited

Enumeration of the sound source states.

Enumerator
Stopped | Sound is not playing.
Paused | Sound is paused.
Playing | Sound is playing.

Definition at line 54 of file SoundSource.hpp.

## Constructor & Destructor Documentation

## ◆ ~SoundStream()

sf::SoundStream::~SoundStream | ( |  | ) |
| override

Destructor.

## ◆ SoundStream() [1/2]

sf::SoundStream::SoundStream | ( | SoundStream && |  | ) |
| noexcept

Move constructor.

## ◆ SoundStream() [2/2]

sf::SoundStream::SoundStream | ( |  | ) |
| protected

Default constructor.

This constructor is only meant to be called by derived classes.

## Member Function Documentation

## ◆ getAttenuation()

float sf::SoundSource::getAttenuation | ( |  | ) | const
| nodiscardinherited

Get the attenuation factor of the sound.

Returns
  Attenuation factor of the sound

See also
  `setAttenuation`, `getMinDistance`

## ◆ getChannelCount()

unsigned int sf::SoundStream::getChannelCount | ( |  | ) | const
| nodiscard

Return the number of channels of the stream.

1 channel means a mono sound, 2 means stereo, etc.

Returns
  Number of channels

## ◆ getChannelMap()

std::vector< SoundChannel > sf::SoundStream::getChannelMap | ( |  | ) | const
| nodiscard

Get the map of position in sample frame to sound channel.

This is used to map a sample in the sample stream to a position during spatialization.

Returns
  Map of position in sample frame to sound channel

## ◆ getCone()

Cone sf::SoundSource::getCone | ( |  | ) | const
| nodiscardinherited

Get the cone properties of the sound in the audio scene.

Returns
  Cone properties of the sound

See also
  `setCone`

## ◆ getDirection()

Vector3f sf::SoundSource::getDirection | ( |  | ) | const
| nodiscardinherited

Get the 3D direction of the sound in the audio scene.

Returns
  Direction of the sound

See also
  `setDirection`

## ◆ getDirectionalAttenuationFactor()

float sf::SoundSource::getDirectionalAttenuationFactor | ( |  | ) | const
| nodiscardinherited

Get the directional attenuation factor of the sound.

Returns
  Directional attenuation factor of the sound

See also
  `setDirectionalAttenuationFactor`

## ◆ getDopplerFactor()

float sf::SoundSource::getDopplerFactor | ( |  | ) | const
| nodiscardinherited

Get the doppler factor of the sound.

Returns
  Doppler factor of the sound

See also
  `setDopplerFactor`

## ◆ getMaxDistance()

float sf::SoundSource::getMaxDistance | ( |  | ) | const
| nodiscardinherited

Get the maximum distance of the sound.

Returns
  Maximum distance of the sound

See also
  `setMaxDistance`, `getAttenuation`

## ◆ getMaxGain()

float sf::SoundSource::getMaxGain | ( |  | ) | const
| nodiscardinherited

Get the maximum gain of the sound.

Returns
  Maximum gain of the sound

See also
  `setMaxGain`, `getAttenuation`

## ◆ getMinDistance()

float sf::SoundSource::getMinDistance | ( |  | ) | const
| nodiscardinherited

Get the minimum distance of the sound.

Returns
  Minimum distance of the sound

See also
  `setMinDistance`, `getAttenuation`

## ◆ getMinGain()

float sf::SoundSource::getMinGain | ( |  | ) | const
| nodiscardinherited

Get the minimum gain of the sound.

Returns
  Minimum gain of the sound

See also
  `setMinGain`, `getAttenuation`

## ◆ getPan()

float sf::SoundSource::getPan | ( |  | ) | const
| nodiscardinherited

Get the pan of the sound.

Returns
  Pan of the sound

See also
  `setPan`

## ◆ getPitch()

float sf::SoundSource::getPitch | ( |  | ) | const
| nodiscardinherited

Get the pitch of the sound.

Returns
  Pitch of the sound

See also
  `setPitch`

## ◆ getPlayingOffset()

Time sf::SoundStream::getPlayingOffset | ( |  | ) | const
| nodiscard

Get the current playing position of the stream.

Returns
  Current playing position, from the beginning of the stream

See also
  `setPlayingOffset`

## ◆ getPosition()

Vector3f sf::SoundSource::getPosition | ( |  | ) | const
| nodiscardinherited

Get the 3D position of the sound in the audio scene.

Returns
  Position of the sound

See also
  `setPosition`

## ◆ getSampleRate()

unsigned int sf::SoundStream::getSampleRate | ( |  | ) | const
| nodiscard

Get the stream sample rate of the stream.

The sample rate is the number of audio samples played per second. The higher, the better the quality.

Returns
  Sample rate, in number of samples per second

## ◆ getStatus()

Status sf::SoundStream::getStatus | ( |  | ) | const
| nodiscardoverridevirtual

Get the current status of the stream (stopped, paused, playing)

Returns
  Current status

Implements sf::SoundSource.

## ◆ getVelocity()

Vector3f sf::SoundSource::getVelocity | ( |  | ) | const
| nodiscardinherited

Get the 3D velocity of the sound in the audio scene.

Returns
  Velocity of the sound

See also
  `setVelocity`

## ◆ getVolume()

float sf::SoundSource::getVolume | ( |  | ) | const
| nodiscardinherited

Get the volume of the sound.

Returns
  Volume of the sound, in the range [0, 100]

See also
  `setVolume`

## ◆ initialize()

void sf::SoundStream::initialize | ( | unsigned int | channelCount,
|  | unsigned int | sampleRate,
|  | const std::vector< SoundChannel > & | channelMap )
| protected

Define the audio stream parameters.

This function must be called by derived classes as soon as they know the audio settings of the stream to play. Any attempt to manipulate the stream (`play()`, ...) before calling this function will fail. It can be called multiple times if the settings of the audio stream change, but only when the stream is stopped.

Parameters

  channelCount | Number of channels of the stream
  sampleRate | Sample rate, in samples per second
  channelMap | Map of position in sample frame to sound channel

## ◆ isLooping()

bool sf::SoundStream::isLooping | ( |  | ) | const
| nodiscard

Tell whether or not the stream is in loop mode.

Returns
  `true` if the stream is looping, `false` otherwise

See also
  `setLooping`

## ◆ isRelativeToListener()

bool sf::SoundSource::isRelativeToListener | ( |  | ) | const
| nodiscardinherited

Tell whether the sound's position is relative to the listener or is absolute.

Returns
  `true` if the position is relative, `false` if it's absolute

See also
  `setRelativeToListener`

## ◆ isSpatializationEnabled()

bool sf::SoundSource::isSpatializationEnabled | ( |  | ) | const
| nodiscardinherited

Tell whether spatialization of the sound is enabled.

Returns
  `true` if spatialization is enabled, `false` if it's disabled

See also
  `setSpatializationEnabled`

## ◆ onGetData()

virtual bool sf::SoundStream::onGetData | ( | Chunk & | data | ) |
| nodiscardprotectedpure virtual

Request a new chunk of audio samples from the stream source.

This function must be overridden by derived classes to provide the audio samples to play. It is called continuously by the streaming loop, in a separate thread. The source can choose to stop the streaming loop at any time, by returning `false` to the caller. If you return `true` (i.e. continue streaming) it is important that the returned array of samples is not empty; this would stop the stream due to an internal limitation.

Parameters

  data | Chunk of data to fill

Returns
  `true` to continue playback, `false` to stop

Implemented in sf::Music.

## ◆ onLoop()

virtual std::optional< std::uint64_t > sf::SoundStream::onLoop | ( |  | ) |
| protectedvirtual

Change the current playing position in the stream source to the beginning of the loop.

This function can be overridden by derived classes to allow implementation of custom loop points. Otherwise, it just calls `onSeek(Time::Zero)` and returns 0.

Returns
  The seek position after looping (or `std::nullopt` if there's no loop)

Reimplemented in sf::Music.

## ◆ onSeek()

virtual void sf::SoundStream::onSeek | ( | Time | timeOffset | ) |
| protectedpure virtual

Change the current playing position in the stream source.

This function must be overridden by derived classes to allow random seeking into the stream source.

Parameters

  timeOffset | New playing position, relative to the beginning of the stream

Implemented in sf::Music.

## ◆ operator=()

SoundStream & sf::SoundStream::operator= | ( | SoundStream && |  | ) |
| noexcept

Move assignment.

## ◆ pause()

void sf::SoundStream::pause | ( |  | ) |
| overridevirtual

Pause the audio stream.

This function pauses the stream if it was playing, otherwise (stream already paused or stopped) it has no effect.

See also
  `play`, `stop`

Implements sf::SoundSource.

## ◆ play()

void sf::SoundStream::play | ( |  | ) |
| overridevirtual

Start or resume playing the audio stream.

This function starts the stream if it was stopped, resumes it if it was paused, and restarts it from the beginning if it was already playing. This function uses its own thread so that it doesn't block the rest of the program while the stream is played.

See also
  `pause`, `stop`

Implements sf::SoundSource.

## ◆ setAttenuation()

void sf::SoundSource::setAttenuation | ( | float | attenuation | ) |
| inherited

Set the attenuation factor of the sound.

The attenuation is a multiplicative factor which makes the sound more or less loud according to its distance from the listener. An attenuation of 0 will produce a non-attenuated sound, i.e. its volume will always be the same whether it is heard from near or from far. On the other hand, an attenuation value such as 100 will make the sound fade out very quickly as it gets further from the listener. The default value of the attenuation is 1.

Parameters

  attenuation | New attenuation factor of the sound

See also
  `getAttenuation`, `setMinDistance`

## ◆ setCone()

void sf::SoundSource::setCone | ( | const Cone & | cone | ) |
| inherited

Set the cone properties of the sound in the audio scene.

The cone defines how directional attenuation is applied. The default cone of a sound is (2 * PI, 2 * PI, 1).

Parameters

  cone | Cone properties of the sound in the scene

See also
  `getCone`

## ◆ setDirection()

void sf::SoundSource::setDirection | ( | const Vector3f & | direction | ) |
| inherited

Set the 3D direction of the sound in the audio scene.

The direction defines where the sound source is facing in 3D space. It will affect how the sound is attenuated if facing away from the listener. The default direction of a sound is (0, 0, -1).

Parameters

  direction | Direction of the sound in the scene

See also
  `getDirection`

## ◆ setDirectionalAttenuationFactor()

void sf::SoundSource::setDirectionalAttenuationFactor | ( | float | factor | ) |
| inherited

Set the directional attenuation factor of the sound.

Depending on the virtual position of an output channel relative to the listener (such as in surround sound setups), sounds will be attenuated when emitting them from certain channels. This factor determines how strong the attenuation based on output channel position relative to the listener is.

Parameters

  factor | New directional attenuation factor to apply to the sound

See also
  `getDirectionalAttenuationFactor`

## ◆ setDopplerFactor()

void sf::SoundSource::setDopplerFactor | ( | float | factor | ) |
| inherited

Set the doppler factor of the sound.

The doppler factor determines how strong the doppler shift will be.

Parameters

  factor | New doppler factor to apply to the sound

See also
  `getDopplerFactor`

## ◆ setEffectProcessor()

void sf::SoundStream::setEffectProcessor | ( | EffectProcessor | effectProcessor | ) |
| overridevirtual

Set the effect processor to be applied to the sound.

The effect processor is a callable that will be called with sound data to be processed.

Parameters

  effectProcessor | The effect processor to attach to this sound, attach an empty processor to disable processing

Reimplemented from sf::SoundSource.

## ◆ setLooping()

void sf::SoundStream::setLooping | ( | bool | loop | ) |

Set whether or not the stream should loop after reaching the end.

If set, the stream will restart from beginning after reaching the end and so on, until it is stopped or `setLooping(false)` is called. The default looping state for streams is `false`.

Parameters

  loop | `true` to play in loop, `false` to play once

See also
  `isLooping`

## ◆ setMaxDistance()

void sf::SoundSource::setMaxDistance | ( | float | distance | ) |
| inherited

Set the maximum distance of the sound.

The "maximum distance" of a sound is the minimum distance at which it is heard at its minimum volume. Closer than the maximum distance, it will start to fade in according to its attenuation factor. The default value of the maximum distance is the maximum value a float can represent.

Parameters

  distance | New maximum distance of the sound

See also
  `getMaxDistance`, `setAttenuation`

## ◆ setMaxGain()

void sf::SoundSource::setMaxGain | ( | float | gain | ) |
| inherited

Set the maximum gain of the sound.

When the sound is closer from the listener than the "minimum distance" the attenuated gain is clamped so it cannot go above the maximum gain value.

Parameters

  gain | New maximum gain of the sound

See also
  `getMaxGain`, `setAttenuation`

## ◆ setMinDistance()

void sf::SoundSource::setMinDistance | ( | float | distance | ) |
| inherited

Set the minimum distance of the sound.

The "minimum distance" of a sound is the maximum distance at which it is heard at its maximum volume. Further than the minimum distance, it will start to fade out according to its attenuation factor. A value of 0 ("inside the head of the listener") is an invalid value and is forbidden. The default value of the minimum distance is 1.

Parameters

  distance | New minimum distance of the sound

See also
  `getMinDistance`, `setAttenuation`

## ◆ setMinGain()

void sf::SoundSource::setMinGain | ( | float | gain | ) |
| inherited

Set the minimum gain of the sound.

When the sound is further away from the listener than the "maximum distance" the attenuated gain is clamped so it cannot go below the minimum gain value.

Parameters

  gain | New minimum gain of the sound

See also
  `getMinGain`, `setAttenuation`

## ◆ setPan()

void sf::SoundSource::setPan | ( | float | pan | ) |
| inherited

Set the pan of the sound.

Using panning, a mono sound can be panned between stereo channels. When the pan is set to -1, the sound is played only on the left channel, when the pan is set to +1, the sound is played only on the right channel.

Parameters

  pan | New pan to apply to the sound [-1, +1]

See also
  `getPan`

## ◆ setPitch()

void sf::SoundSource::setPitch | ( | float | pitch | ) |
| inherited

Set the pitch of the sound.

The pitch represents the perceived fundamental frequency of a sound; thus you can make a sound more acute or grave by changing its pitch. A side effect of changing the pitch is to modify the playing speed of the sound as well. The default value for the pitch is 1.

Parameters

  pitch | New pitch to apply to the sound

See also
  `getPitch`

## ◆ setPlayingOffset()

void sf::SoundStream::setPlayingOffset | ( | Time | timeOffset | ) |

Change the current playing position of the stream.

The playing position can be changed when the stream is either paused or playing. Changing the playing position when the stream is stopped has no effect, since playing the stream would reset its position.

Parameters

  timeOffset | New playing position, from the beginning of the stream

See also
  `getPlayingOffset`

## ◆ setPosition()

void sf::SoundSource::setPosition | ( | const Vector3f & | position | ) |
| inherited

Set the 3D position of the sound in the audio scene.

Only sounds with one channel (mono sounds) can be spatialized. The default position of a sound is (0, 0, 0).

Parameters

  position | Position of the sound in the scene

See also
  `getPosition`

## ◆ setRelativeToListener()

void sf::SoundSource::setRelativeToListener | ( | bool | relative | ) |
| inherited

Make the sound's position relative to the listener or absolute.

Making a sound relative to the listener will ensure that it will always be played the same way regardless of the position of the listener. This can be useful for non-spatialized sounds, sounds that are produced by the listener, or sounds attached to it. The default value is `false` (position is absolute).

Parameters

  relative | `true` to set the position relative, `false` to set it absolute

See also
  `isRelativeToListener`

## ◆ setSpatializationEnabled()

void sf::SoundSource::setSpatializationEnabled | ( | bool | enabled | ) |
| inherited

Set whether spatialization of the sound is enabled.

Spatialization is the application of various effects to simulate a sound being emitted at a virtual position in 3D space and exhibiting various physical phenomena such as directional attenuation and doppler shift.

Parameters

  enabled | `true` to enable spatialization, `false` to disable

See also
  `isSpatializationEnabled`

## ◆ setVelocity()

void sf::SoundSource::setVelocity | ( | const Vector3f & | velocity | ) |
| inherited

Set the 3D velocity of the sound in the audio scene.

The velocity is used to determine how to doppler shift the sound. Sounds moving towards the listener will be perceived to have a higher pitch and sounds moving away from the listener will be perceived to have a lower pitch.

Parameters

  velocity | Velocity of the sound in the scene

See also
  `getVelocity`

## ◆ setVolume()

void sf::SoundSource::setVolume | ( | float | volume | ) |
| inherited

Set the volume of the sound.

The volume is a value between 0 (mute) and 100 (full volume). The default value for the volume is 100.

Parameters

  volume | Volume of the sound

See also
  `getVolume`

## ◆ stop()

void sf::SoundStream::stop | ( |  | ) |
| overridevirtual

Stop playing the audio stream.

This function stops the stream if it was playing or paused, and does nothing if it was already stopped. It also resets the playing position (unlike `pause()`).

See also
  `play`, `pause`

Implements sf::SoundSource.

The documentation for this class was generated from the following file:

- SoundStream.hpp